//===============================================================
//=	PSoCɂ鉼zCOM|[gvO			=
//=								=
//===============================================================

#include <m8c.h>        // part specific constants and macros
#include "PSoCAPI.h"    // PSoC API definitions for all User Modules
//#include "USB.h"
#include "cstdef.h"
#include "cstdio.h"
#include "print.h"
#include "mmc.h"

extern void exec_cmd(unsigned char *cmdptr);

extern BYTE SOF_Flag;		// SOFJE^
unsigned char line_code[7]   = {0x80,0x25,0x00,0x00,0x02,0x01,0x08};

#pragma abs_address:0x100
unsigned char	txbuf[TXBUFSIZE];
unsigned char	rxbuf[RXBUFSIZE+1];
unsigned char	cmdbuf[RXBUFSIZE+1];
unsigned char	secbuf[SECBUFSIZE];
#pragma end_abs_address

unsigned char	txpos;
unsigned char 	cmdpos;
unsigned char	rxpos = 0;	// rxbufoĂꏊ
unsigned char	rxcount = 0;	// rxbufɓĂf[^


void initial_msg(void)
{
	printf("Hello PSoC!\n");
}



//===============================================================
//= get_line()							=
//= zXg痈̂rxbufŎ󂯂AcmdbufɂPs		=
//=iCR܂Łj]						=
//= CRPs̏IBnCp[^[~i̓][hg	=
//= CRŐ؂炸ɑĂ̂ŁACR܂ŏAget_line()=
//= ő󂯎悤ɍ׍HKv				=
//===============================================================
//
void get_line()
{
	unsigned char brk,c;
	brk = 0;
	cmdpos = 0;		// R}hobt@̐擪n߂
	while(1) {		// Rs[[v
		while ((rxpos < rxcount) && !brk) {	// rxposŌ܂ōsĂȂȂRs[ׂ̂
			if (cmdpos >= RXBUFSIZE) {	// ̂R}hobt@ςɂȂĂ܂
				brk = 1;
				break;
			}
			switch(c = (cmdbuf[cmdpos] = rxbuf[rxpos])) {
				case	LF:	rxpos++;	// LF͓ǂݔ΂
						break;
				case	CR:	rxpos++;	// CR̎̃R}ḧׂɐi߂Ă
						brk = 1;
						break;
				case	BS:	if (cmdpos) {	// ꕶ߂
							cmdpos--;
							printf("%c %c",BS,BS);
						}
						rxpos++;
						break;
				case	EOS:	break;		// EOSȂ犮
				default:	if ((c >= 'a') && (c <= 'z')) {
							c = c- 'a'+ 'A';
							cmdbuf[cmdpos] = c;
						}
						cmdpos++;	// ЂƂi߂
						rxpos++;
						printf("%c",c);
						break;
			}
		}
		if (brk) {	// 
			cmdbuf[cmdpos] = EOS;	// EOSďI点
			printf("\n");
			break;
		}
		// ̍s擾
		rxpos = 0;						// A擪w
		while(USBFS_1_bGetEPState(1) != OUT_BUFFER_FULL)	// f[^҂
			;
		rxcount = USBFS_1_bReadOutEP(1,&rxbuf[0], RXBUFSIZE);	// 荞
		USBFS_1_EnableOutEP(1);					// ̃f[^荞݉\ɂĂ
	}
	return;
}


void main()
{
	unsigned char c;
	PRT2DR = 0xff;
	M8C_EnableGInt;
	PGA_1_Start(PGA_1_HIGHPOWER);
	DelSig_1_Start(DelSig_1_HIGHPOWER);
	SPIM_1_Start(SPIM_1_SPIM_MODE_3 | SPIM_1_SPIM_MSB_FIRST);
	USBFS_1_Start(0,USB_5V_OPERATION);
	USBFS_1_INT_REG = 0xbf;
	while(!USBFS_1_bGetConfiguration())
		;
	USBFS_1_EnableOutEP(1);
	get_line();
	printf("\n***** USB PSoC Monitor Version 1.1 *****");
	while(1) {
		printf("\n*Ready.\n");
		get_line();
		if (cmdbuf[0] == EOS) {		// 
			initial_msg();
		} else {
			// printf("[%s]\n",cmdbuf);
			exec_cmd(cmdbuf);
		}
	}
}
